/*
 * File         : test2.hpj
 * Author       : Qiang Zheng
 * Created      : Wed Oct 18 1998
 * Revision     : $Revision: 1.0 $
 * Updated      : $Date: 1998/10/14 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

// real a(32), b(200)
// !hpf$ distribute a (block) onto p
// !hpf$ distribute b (block (100)) onto p
// !hpf$ processors p (4)
//
// do i=1,200
//   b(i) = i
// enddo
// do i=1,32
//   a(i) = 1000*i
// enddo
//
// a (10:19) = b (100 : 190 : 10)
//
// do i=1,32
//   print "(F12.2)", a(i)
// enddo
//
// end

import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

class test2 {
  public static void main(String argv[]) {
	SpmdEnv spmd=new SpmdEnv(argv);

	Procs1 p = new Procs1(4);
	Range x = new BlockRange(32,p.dim(0));
	Array1dF a = new Array1dF(spmd.apg,x);

	// Range y = new BlockRange(200,p.dim(0),100);
	Range y = new BlockRange(200,p.dim(0));
	Array1dF b = new Array1dF(spmd.apg,y);

	if (p.on()) {
		Index i = new Index(x);

		i.dim().over();
		for(i.begin(); i.test(); i.next()) {
			a.dat()[a.pos(i)] = 1000 * (1 + x.idx(i));
		} i.dim().revo();

		Index j = new Index(y);

		j.dim().over();
		for(j.begin(); j.test(); j.next()) {
			b.dat()[b.pos(j)] = 1 + y.idx(j);
		} j.dim().revo();

		Range xs = x.subrng(10,9);
		Range ys = y.subrng(10,99,10);
		// Range xs = x.subrng(19,10);
		// Range ys = y.subrng(190,100,10); 
		// In test1.java in test/adJava it is y.subrng(10,99,10) Why?
		// Adlib.remap(a.section(xs),b.section(ys));
		
		Array1dF seca = new Array1dF(p,xs,a.str()[0],a.dat(),a.off());
		Array1dF secb = new Array1dF(p,ys,b.str()[0],b.dat(),b.off());
		Adlib.remap(seca,secb);

	} p.no();	
	Adlib.aprintf("%12.2f\n", a);
	// Adlib.aprintf("%12.2f\n", a);
	spmd.finalize();
  }
}
